#!/usr/bin/perl
use File::Find;
use POSIX qw(strftime);
use strict;
#use warnings;

# variables globales
#parametres
#my($TRAITETUNNEL) = "VRAI" ;
my($TRAITETUNNEL) = "FAUX" ; # les interfaces de type tunnel ou pseudo tunnel ne sont pas pises en compte du tout
my($seuilconf) = 0.51 ; # seuil pour grande confiance
my($WHOB) = "FAUX" ; # les prefixes inconnus dans le fichier ne sont pas recherches mais remplaces par INCONNU
my($LANsansd) = "VRAI"  ;  # si "VRAI" on ne traite pas le cas "d" des interfaces LAN
my($verbose) = "VRAI"; # change le mode d'affichage  des routeurs
my($NomFichierEntree) ;
my($FichierPrefixeEntree) ;
my($NomFichierListeNoeud) ;
my($NomFichierLocal) ;
my($NomFichierC2P) ;
my($ModeInteractif) = "FAUX" ; # positionné par -i ligne de commande
my($ModeC2P) = "FAUX" ; # positionné par -c sur ligne de commande
my($step);  #etape de la valisation des AS
my(%interface_routeur) = ();  # hash adressse interface gauche => liste adresse routeur suivi des adresses des voisins
my(%interface_droite) = () ; # hash adresse interface droite => derniere interface gauche vue
my(%adresse_reponse) =(); # hash qui indique si une adresse correspond a un routeur parcouru 
my(%adresse_ID) = () ; # hash adresse routeur => numero routeur
my(%ID_ASN) = () ; #hash ID_routeur => ASN passe 2
my(%ID_intra) = (); # hash ID_routeur => intradomaine passe 2
my(%ID_ambigu) =(); # hash ID_routeur => VRAI si ambigu
my(%fqdn) = () ; # hash adresse IP => FQDN 
my(%loopback) = () ; # hash adresse IP => nom si loopback
my($compteur_routeur) = 0 ; #nombre de routeurs deja vus = numero du prochain routeur
my(%interface_switch) =(); # hash adresse interface => numero switch
my($compteur_switch) = 0; # nombre de switchs deja vus = numero du prochain switch
my(@table_noeud) = () ; # table des routeurs et switchs, chaque element est un record
# NOEUDID numero du routeur
# TYPENOEUD ROUTEUR ou SWITCH
# VERSION version de l'OS
# NOMR nom DNS du routeur
# NOM_INTERNE  non canonique d'une interface du routeur dans AS du routeur
# ADDR adresse IP du routeur ou prefixe du switch
# VISITE VISITE ou NONVISITE par mrinfo
# ASN estime
# CONF confiance estimee de ASN
# ASNT  table AS estime d après voisinage tunnel
# ASNL AS estimé d apres interface loopback
# INTER  intra ou inter ou ?
# LISTINT est un  tableau d interface, un record par interface
# LISTLOC est un hash des  les adresses gauches locales routeur
# LISTAS est une liste de liste le ieme element est le couple ASi Fi 
#  ou ASi est le ieme plus frequent, apparaissant Fi fois
#  en particulier ASN est intialise a LISTAS [0][0] 
# COMMENT  chaine contenant des commentaires sur le choix d'AS
# HISTO chaine [code]stepi AS Confiance  i fois     sans ls ienconsistances de voisinage
# HISTO_INCF idem mais uniquement ls inconsistancs
#### un record du type interface a les membres suivants 
# on ne considere que des interfaces ou l'adresse droite et l'adresse gauche sont globales
# les lignes où interface gauche LOCAL ou PRIVATE pas inseree
# ADDRG adresse IP gauche
# ADDRD adresse IP droite
# NOMDROIT
# TYPEINT  : GLOBAL, SWITCH
# ASNG : ASN de ADDRG
# ASND : ASN de ADDRD
# VOISIN ID du voisin si GLOBAL ou SWITCH
my(@newconf1) =(); # liste de noeuds qui sont passes a confiance 1

sub imprime_routeur_detail {
# on passe en parametre ID du routeur
	my($ID_routeur) = shift ;
	my($ref) = $table_noeud[$ID_routeur];
	my($noeudid) = %{$ref}->{"NOEUDID"} ;
	my($typenoeud) = %{$ref}->{"TYPENOEUD"} ;
	my($nom) = (exists %{$ref}->{"NOMR"}) ? " " . %{$ref}->{"NOMR"}. ","  : ""  ;
	my($nom_interne) = (exists %{$ref}->{"NOM_INTERNE"} ) ? " NOM INTERNE " . %{$ref}->{"NOM_INTERNE"} . "," : "" ;
# on parcourt maintenant les routeurs visites
	my($addr) = (exists  %{$ref}->{"ADDR"}) ? " " . %{$ref}->{"ADDR"}."," : "" ;
	my($visite) = (exists %{$ref}->{"VISITE"}) ? " " . %{$ref}->{"VISITE"}."," : "" ;
	my($AS) = ( exists %{$ref}->{"ASN"} ) ?  "AS" . %{$ref}->{"ASN"} : "";
	my($CONF) =  ( exists%{$ref}->{"CONF"} ) ?  "(" . %{$ref}->{"CONF"} . ")" : "" ;
	my($ASNT) =  ( exists %{$ref}->{"ASNT"} ) ?  " ,ASNT" . %{$ref}->{"ASNT"}[0] : "" ; 
	my($ASNL) = ( exists %{$ref}->{"ASNL"} ) ?  " ,ASNL" . %{$ref}->{"ASNL"} :  "" ; 
	my($type) = %{$ref}->{"INTER"};
	my($versionos) = (%{$ref}->{"VISITE"} eq "VISITE"  ) ? %{$ref}->{"VERSION"} : "" ;
	my($histo) = %{$ref} -> {"HISTO"} ;
	my($histo_inc) =  (exists %{$ref} -> {"HISTO_INC"})  ? %{$ref} -> {"HISTO_INC"} : "" ;
	print "ID $noeudid $typenoeud$nom$nom_interne$addr$visite $AS$CONF$ASNT$ASNL, $type $versionos \n" ;
	if (exists %{$ref}->{"COMMENT"} ) {
		print %{$ref}->{"COMMENT"} . "\n" ;
	}
	print "HISTO " . $histo . "\n" ;
	print "HISTO_INC " . $histo_inc . "\n" ;
	my(@listloc) = keys (%{%{$ref}->{"LISTLOC"}} ) ; 
	if ( $#listloc >= 0 ) {
		my($nloc) = $#listloc + 1;
		print "\t Liste des $nloc adresses locales \n";
		foreach $addr (@listloc) {
			my($nomg) = ( exists $fqdn{$addr} ) ? "(" .$fqdn{$addr} . ")" : "" ;
			my($as) = &Recherche_AS ($addr);
			print "\t\t $addr$nomg AS$as\n"; 
		}
	}
	if ((%{$ref}->{"VISITE"} eq "VISITE"  ) || (%{$ref}->{"TYPENOEUD"} eq "SWITCH"  ) ) {
		if ( exists %{$ref}->{"LISTINT"} ) { 
			my(@refliste) = @{%{$ref}->{"LISTINT"}} ;
			my($nbint) = $#refliste + 1 ;
			print "\t Nombre interfaces non locales $nbint \n";
			print "\t type adresse_locale \(nom\) AS => adresse_distante \(nom\) AS IDVOISIN \n";
			foreach (@refliste ) {
# imprimer l'interface courante
				my($asng,$asnd);
				my($addrg) = %{$_}->{"ADDRG"} ;
				my($addrd) = %{$_}->{"ADDRD"} ;
				my($nomd) = ( %{$_}->{"NOMDROIT"} ne "" ) ? "(" . %{$_}->{"NOMDROIT"} . ")" : "";
				my($nomg) = ( exists $fqdn{$addrg} ) ? "(" .$fqdn{$addrg} . ")" : "" ;
				my($type) = %{$_}->{"TYPEINT"} ;
				if (exists(%{$_}->{"ASNG"} )) {$asng = "AS" . %{$_}->{"ASNG"} ;}
				if (exists(%{$_}->{"ASND"}))  {$asnd = "AS" . %{$_}->{"ASND"} ;}
				my($voisin) = ( exists %{$_}->{"VOISIN"} ) ? "ID" . %{$_}->{"VOISIN"} : "" ;
				print "\t $type $addrg$nomg $asng => $addrd $nomd  $asnd $voisin\n" ;
			}
		} else {
			print "\t Pas d interface repertoriee \n";
		}
	}
}
sub imprime_routeur_resume {
# on passe en parametre ID du routeur
	my($ID_routeur) = shift ;
	my($ref) = $table_noeud[$ID_routeur];
	my($noeudid) = %{$ref}->{"NOEUDID"} ;
	my($typenoeud) = %{$ref}->{"TYPENOEUD"} ;
	my($nom) = (exists %{$ref}->{"NOMR"}) ? " " . %{$ref}->{"NOMR"}. ","  : ""  ;
# on parcourt maintenant les routeurs visites
	my($addr) = (exists  %{$ref}->{"ADDR"}) ? " " . %{$ref}->{"ADDR"}."," : "" ;
	my($visite) = (exists %{$ref}->{"VISITE"}) ? " " . %{$ref}->{"VISITE"}."," : "" ;
	my($AS) = ( exists %{$ref}->{"ASN"} ) ?  "AS" . %{$ref}->{"ASN"} : "";
	my($CONF) =  ( exists%{$ref}->{"CONF"} ) ?  "(" . %{$ref}->{"CONF"} . ")" : "" ;
	my($ASNT) =  ( exists %{$ref}->{"ASNT"} ) ?  " ,ASNT" . %{$ref}->{"ASNT"}[0] : "" ;
	my($ASNL) = ( exists %{$ref}->{"ASNL"} ) ?  " ,ASNL" . %{$ref}->{"ASNL"} :  "" ;
	my($type) = %{$ref}->{"INTER"};
	my($versionos) = (%{$ref}->{"VISITE"} eq "VISITE"  ) ? %{$ref}->{"VERSION"} : "" ;
	my($nom_interne) = ( exists %{$ref}->{"NOM_INTERNE"} ) ? %{$ref}->{"NOM_INTERNE"} : "";
	print FGRAPHE "ID$noeudid $typenoeud$addr $AS $type $nom_interne \n" ;
###############################################
# Modif 28/1/2010 pour ajouter les interfaces locales A -> 0.0.0.0 ou A est une adresse globale
	 my(@listloc) = keys (%{%{$ref}->{"LISTLOC"}} ) ;
       if ( $#listloc >= 0 ) {
               my($nloc) = $#listloc + 1;
               foreach $addr (@listloc) {
                       my($nomg) = ( exists $fqdn{$addr} ) ? "(" .$fqdn{$addr} . ")" : "" ;
                       my($as) = &Recherche_AS ($addr);
			print FGRAPHE "\t LOCAL $addr$nomg(AS$as) -> 0.0.0.0\n";
               }
       }


# fin modif 28/1/2010
###############################################
	my($ASvoisin) ;
	if ((%{$ref}->{"VISITE"} eq "VISITE"  ) || (%{$ref}->{"TYPENOEUD"} eq "SWITCH"  ) ) {
		if ( exists %{$ref}->{"LISTINT"} ) {
			my(@refliste) = @{%{$ref}->{"LISTINT"}} ;
			my($nbint) = $#refliste + 1 ;
			foreach (@refliste ) {
# imprimer l'interface courante
				my($asng,$asnd);
				my($addrg) = %{$_}->{"ADDRG"} ;
				my($addrd) = %{$_}->{"ADDRD"} ;
				my($nomd) = ( %{$_}->{"NOMDROIT"} ne "" ) ?  %{$_}->{"NOMDROIT"} : "";
				my($nomg) = ( exists $fqdn{$addrg} ) ? $fqdn{$addrg} : "" ;
				my($type) = %{$_}->{"TYPEINT"} ;
				if (exists(%{$_}->{"ASNG"} )) {$asng = "AS" . %{$_}->{"ASNG"} ;}
				if (exists(%{$_}->{"ASND"}))  {$asnd = "AS" . %{$_}->{"ASND"} ;}
				if ( $type eq "SWITCH" ) {
					$asnd = $asng ;
				}
				my($IDvoisin) = ( exists %{$_}->{"VOISIN"} ) ? "ID" . %{$_}->{"VOISIN"} : "" ;
				my($voisin) = ( exists %{$_}->{"VOISIN"} ) ? %{$_}->{"VOISIN"} : "" ;
				$ASvoisin = ( exists  %{$table_noeud[$voisin] } -> {"ASN"} ?  "AS" .%{$table_noeud[$voisin]} -> {"ASN"}  : "" );
				print FGRAPHE "\t $type $addrg($asng)  -> $addrd ($asnd)  $IDvoisin $ASvoisin ( $nomg -> $nomd)  \n" ;
			}
		} else {
		}
	}
}
sub imprime_routeur {
# on passe en parametre ID du routeur
	my($ID_routeur) = shift ;
	if ($verbose eq "VRAI" ) {
		&imprime_routeur_detail($ID_routeur) ;
	} else {
		&imprime_routeur_resume($ID_routeur) ;
	}
}

sub imprime_routeur_interactif {
# boucle sur demande numero routeur et imprime
	my($NumeroRouteur) ;
	my($invite) = "Entrez IDxyz  du noeud  a afficher ou IPA.B.C.D ou ASxyz ou RETURN  \n" ;
	print $invite ;
	$NumeroRouteur =<STDIN>;
	chomp($NumeroRouteur);
	while ( $NumeroRouteur ne "" ) {
		if ( $NumeroRouteur =~ /^ *ID/ ) {
			$NumeroRouteur =~  s/^ *ID *// ;
			print "Routeur a afficher $NumeroRouteur\n" ;
			if ( $NumeroRouteur < 0 || $NumeroRouteur > $#table_noeud ) {
				print "Numero $NumeroRouteur invalide \n" ;
			} else {
				&imprime_routeur($NumeroRouteur);
			}
		} elsif (  $NumeroRouteur =~ /^ *IP/ ) {
			print "Adresse a afficher $NumeroRouteur\n" ;
			$NumeroRouteur =~  s/^ *IP *// ;
			if  ( !  exists  $adresse_ID{ $NumeroRouteur })  {
				print "Adresse invalide ou inconnue \n" ;
			} else {
				my($routeurID) = $adresse_ID{ $NumeroRouteur } ;
				&imprime_routeur($routeurID);
			}
		} elsif ( $NumeroRouteur =~ /^ *AS/ ) {
			$NumeroRouteur =~  s/^ *AS *// ;
			print "AS a lister $NumeroRouteur \n" ;
# on parcourt la table des routeurs
			my($tailleAS) = 0;
			foreach (@table_noeud) {
				if (( %{$_} -> {"TYPENOEUD"} eq "ROUTEUR" ) && ( %{$_} -> {"ASN"} eq $NumeroRouteur ) ) {
					my($routeurID) = %{$_} -> {"NOEUDID"} ;
					&imprime_routeur($routeurID);
					$tailleAS ++ ;
					print "\n" ;
				}
			}
			print "Nombre routeurs dans $NumeroRouteur : $tailleAS \n" ;
		} elsif ($NumeroRouteur =~ /^DI/ ) {
			print "Impressiondes routeurs qui nt une interface avec changement de domaine \n";
		}
		print $invite ;
		$NumeroRouteur =<STDIN>;
		chomp($NumeroRouteur);
	}
}
sub fqdnsub {
# prend en entree une adressse et un nom obtenu par mrinfo qui peut etre un nom ou une addrese IP entoure de parentheses
# rend soit le FQDN soit la chaine vide 
# de plus s'il y a u nom l est stocke dans le hash %fqdn
	my($addr) = shift ;
	my($nom) = shift ;
	if ( $nom =~ /[a-zA-Z]/ ) {
# il ya bien un nom
		$nom =~ s/\(// ;
		$nom =~ s/\)// ;
		$fqdn{$addr} = $nom ;	
		return $nom ;
	} else  {
		return "" ;
	}
}


my(@table_switch) = (); # table de liste : le ieme element est la listes des interfaces du switch i
my(%est_switch) =(); # hash. clé = adresse interface, présente si 2 voisins
my(%prefixes_ASN) =(); # hash prefixes => ASN  un prefixe est code sans sa longueur donc on suppose qu un prefixe n en contient pas un autre
# la valeur est une liste de deux elements : longueur du prefixe puis ASN
my($intra_domaine) =0; # 1 = intra,  0 = inter
my($compteur_noeud) =0;
my($nom_noeud);
my($adresse_noeud);
my($id_routeur);
my(@Liste_addresses,@Liste_addresses_loopback);
my($NomFichierLog) ;
my($NomFichierGraphe);
my($Stat_change_type) = 0 ; # stats sur els routeurs qui deviennent inter a la troisieme passe
my($Stat_routeur) = 0 ; # nombre routeurs
my($Stat_switch) = 0 ; # nombre switchs
my($Stat_prefixe) = 0 ; # nombre prefixes obtenus par whob
my($Stat_routeur_distant) = 0 ; # nombre routeurs uniquement distants
my($Stat_desambi) = 0 ; # nombre de routeurs qui changent d AS a la phase 3

sub premiere_passe {
# lit le fichier mrinfo brut
# cree une table de hash interface_routeur
# clé : adresse interface , contenu : liste adresse routeur, adresses distants ; si 2 distants : switch
# pour chaque adresse publique donne le routeur correspondant
# construit aussi le hash %adresse_ID  @routeur => ID
# construit aussi la table %est_switch indiquant si une interface a plusieurs voisins
# puis la table de hash  %interface_switch : @interface => No switch
# puis la table @table_switch : liste des @ des interfaces du switch i
	my($fichier_source) = @_;
	my($lignes, $ligne, $adresse_routeur, $ID_routeur, $AS1, $AS2);
	my( $num_interface) ;
	my($routeurdouble) ;
	open(FICHIERSOURCE, "$fichier_source") || die ("impossible ouvrir $fichier_source");
	while ($lignes=<FICHIERSOURCE>) {
		my(@ligne) = split(' ',$lignes);
		if ($lignes =~ /^\d/ ) {
# ligne commnence par un chiffre : nouveau routeur
			$adresse_routeur = $ligne[0];
#changement du 18/09/09 il faut tester si ce routeur n'est pas en double
			if ( exists $adresse_ID{$adresse_routeur} ) {
# le routeur a été collecté deux fois avec la meme adresse de repondeur
				$routeurdouble = "VRAI";
				print FLOG "ROUTEUR $adresse_routeur en double\n";
				next ;
			}
			$routeurdouble = "FAUX" ;
#on lui donne un numero
			$adresse_ID{$adresse_routeur}  = $compteur_routeur ;
			$adresse_reponse{$adresse_routeur} = "VRAI";
			$ID_routeur=$compteur_routeur ; 
# on cree le routeur
			%{$table_noeud[$ID_routeur]} -> { "NOEUDID"} = $ID_routeur ;
			%{$table_noeud[$ID_routeur]} -> { "TYPENOEUD"} = "ROUTEUR" ;
			%{$table_noeud[$ID_routeur]} -> { "VERSION"} = $ligne[2]. " " . $ligne[3]  ;
			%{$table_noeud[$ID_routeur]} -> { "ADDR"} = $adresse_routeur ;
			%{$table_noeud[$ID_routeur]} -> { "NOMR"} = &fqdnsub($ligne[0],$ligne[1] )  ;
			%{$table_noeud[$ID_routeur]} -> { "VISITE" } = "VISITE" ;
			if ( $ligne[1] =~ /oopback|[^a-zA-Z]lo0|[^a-zA-Z]loop0/ ){
				$loopback{$adresse_routeur} = $ligne[1] ;
			}
			$compteur_routeur ++ ;
			$num_interface = 0;
		} elsif (($lignes =~ /^\s/ ) && !($lignes =~ /\[.*(down|disabled)/ )) {
# ligne commence par espace : interface
# changement du 18/9/09  on skip les interfaces du routeur en double
			if ($routeurdouble eq "VRAI" ) {
				next ;
			}
# si l'adresse est globale on l'ajoute au hash
			my($adresse_int) = $ligne[0];
			my($adresse_distant) = $ligne[2];
# on teste si cette adresse est loopback et si oui on la memorise
			if ( $ligne[3] =~ /oopback|[^a-zA-Z]lo0|[^a-zA-Z]loop0/ ){
				$loopback{$adresse_distant} = $ligne[3] ;
			}

# changement du 24/8 : on teste les interfaces tunnel mais on ne les ajoute pas aux interfaces
			if (( $lignes =~ /\[.*tunnel/ ) && ( $TRAITETUNNEL eq "VRAI")) {
# si adresse gauche globale et adresse droite globale et dans un autre AS on note AS dans ASNT
				if ((&adresse_globale($adresse_int) eq "GLOBAL") && ( &adresse_globale($adresse_distant)  eq "GLOBAL") ) {
					my($AS1) = &Recherche_AS($adresse_int) ;
					my($AS2) = &Recherche_AS($adresse_distant);
					if ( $AS1 ne $AS2) {
						if ( (exists %{$table_noeud[$ID_routeur]}-> {"ASNT"}  ) && ( @{%{$table_noeud[$ID_routeur]}-> {"ASNT"}} [0] ne $AS1 )) {
							print "WARNING tunnels AS inconsistants  $ID_routeur $AS1 \n" ;
						} else {
#print "2 sources de tunnel consistantes \n" ;
						}
						push(@{%{$table_noeud[$ID_routeur]}-> {"ASNT"}}, $AS1 ); 
					} else {
						print FLOG "On ignore ce tunnel $lignes \n" ;
					}
				}
				next ; # on passe a la ligne suivante
			} elsif ( $lignes =~ /\[.*tunnel/ ) {
# on ignore completement
				next ;
			}
			my($numint) = $num_interface ;
# pointeur vers le record de cette nouvelle interface
			if  ( &adresse_globale($adresse_int)  eq "GLOBAL" ) {
				if ($adresse_int eq $adresse_distant ) {
# on fait le choix d ignorer
					print FLOG "WARNING rebouclage : $lignes \n" ;
				} else {
# on teste si la meme adresse globale nest pas assignee a un autre routeur
					if ( exists ( $interface_routeur{$adresse_int} )) {
# deja vu cette adresse
# on teste si c est le meme routeur = switch
# ou bien anomalie
						if  (@{$interface_routeur{$adresse_int}}[0]  ne $adresse_routeur ) {
# on ne la traite pas
# A VOIR on pourrait tester si le meme routeur a repondu 2 fois avec adresses differentes
							print FLOG "WARNING doublon $adresse_int utilisee par @{$interface_routeur{$adresse_int}}[0] et  $adresse_routeur\n"; 
						} elsif ( (&adresse_globale($adresse_distant) eq "GLOBAL") )   {
# modif du 24/8/09 : si le distant est pas GLOBAL on ne l'ajoute pas
# si distant global mais AS different on ajoute pas => tunnel
							$AS1 = &Recherche_AS($adresse_int) ;
							$AS2 = &Recherche_AS($adresse_distant);
							if ($AS1 eq $AS2) {
# switch : on ajoute adresse du distant 
								push(@{$interface_routeur{$adresse_int}}, $adresse_distant );
								$est_switch{$adresse_int} ++;
								$interface_droite{$adresse_distant} = $adresse_int ;
								&fqdnsub($adresse_distant, $ligne[3]) ;
# trouvons le numero d interface avec cette adresse
								my($intprec) = -1 ;
								my(@refliste) = @{%{$table_noeud[$ID_routeur]}->{"LISTINT"}} ;
								foreach (@refliste ) {
									if ( %{$_} -> {"ADDRG"} eq $adresse_int ) {
										$intprec= $_;
										last ;
									}
								}
								if ($intprec == -1) { 
									print "ON a un probleme pour enlever interface $adresse_int $adresse_distant \n" ;
								}
								if ( %{$intprec} -> {"TYPEINT"} ne "SWITCH" ) {
# on passe au type switch
									delete(%{$intprec} -> {"NOMDROIT"} );
									delete(%{$intprec} -> {"ADDRD"} );
									delete(%{$intprec} -> {"ASND"} );
									%{$intprec} -> {"TYPEINT"} = "SWITCH" ;
								}
							} elsif ( $TRAITETUNNEL eq "VRAI")  {
#pseudo tunnel on ajoute pas interface mais seulement AS dans liste ASNT
								if ( (exists %{$table_noeud[$ID_routeur]}-> {"ASNT"}  ) && ( @{%{$table_noeud[$ID_routeur]}-> {"ASNT"}} [0] ne $AS1 )) {
									print "WARNING tunnels AS inconsistants  $ID_routeur $AS1 \n" ;
								} else {
# 2 tunnels consistants
								}
								push(@{%{$table_noeud[$ID_routeur]}-> {"ASNT"}}, $AS1 );
							} else {
# on ignore pseudo tunnel
							}
						} else {
							print FLOG "On ignore $lignes  car gauche deja vu et droite non globale \n" ;
						} 
					} else {
# nouvelle adresse gauche on ajoute a liste adresses
# on ajoute interface que si adresse droite est globale et si droite et gauche sont dans le meme AS
						if ( &adresse_globale($adresse_distant) eq "GLOBAL" ) {
							$AS1 = &Recherche_AS($adresse_int) ;
							$AS2 = &Recherche_AS($adresse_distant);
							if  ($AS1 ne $AS2) {
								if ($TRAITETUNNEL eq "VRAI" ) {
# pourrait bien aussi être un tunnel
# on ajoute a liste tunnel mais pas interface
									push(@{%{$table_noeud[$ID_routeur]}-> {"ASNT"}}, $AS1 );
									print FLOG "pseudo tunnel $lignes \n" ;
								} else {
# on ignore simplement la ligne
									print FLOG "On ignore ligne pseudo tunnel $lignes \n";
								}
							} else {
# et on ajoute adresse interface distante
								push(@{$interface_routeur{$adresse_int}}, $adresse_routeur)  ;
								push(@{$interface_routeur{$adresse_int}}, $adresse_distant );
								%{$table_noeud[$ID_routeur]}-> {"LISTINT"} [$numint] -> {"ADDRG"} = $adresse_int;
								my($ref) = %{$table_noeud[$ID_routeur]}-> {"LISTINT"} [$numint] ;
								%{$table_noeud[$ID_routeur]}-> {"LISTINT"} [$numint] -> {"ASNG"} = $AS1;
								%{$table_noeud[$ID_routeur]}-> {"LISTINT"} [$numint] -> {"ADDRD"} = $adresse_distant ;
								$num_interface++ ;
# on assigne id routeur à interface
								$adresse_ID{$adresse_int} = $ID_routeur ;
								$interface_droite{$adresse_distant} = $adresse_int ;
								%{$table_noeud[$ID_routeur]}-> {"LISTINT"} [$numint] -> {"ASND"} = $AS2;
								%{$table_noeud[$ID_routeur]}-> {"LISTINT"} [$numint] -> {"TYPEINT"} = "GLOBAL" ;
								%{$table_noeud[$ID_routeur]}-> {"LISTINT"} [$numint] -> {"NOMDROIT"} = &fqdnsub($adresse_distant,$ligne[3]);
							}
						} elsif ( &adresse_globale($adresse_distant) eq "LOCAL" ) {
# on ajoute à la liste des adresses locales
# VERRUE pour le moment on ajoute pas une adresse locale dont l'AS est inconnu
							if ( &Recherche_AS($adresse_int) ne "INCONNU") { 
								%{$table_noeud[$ID_routeur]}-> {"LISTLOC"} {$adresse_int} = "VRAI" ;
							}
						} # on ne traite pas les autres lignes, adresses privees notamment
					}
				}
			} 
# traitement adresse gauche locale  ou prive a faire
		} else { print FLOG "WARNING ligne non prise en compte \n" ;
			print FLOG "$lignes \n";
		}
	}
	print "Nombre de  routeurs parcourus $compteur_routeur \n";
### on cree les pseudo routeurs apparaissant seulement a droite
	my($addr) ;
	foreach $addr (keys %interface_droite) {
		if ( (! exists ($interface_routeur{$addr})) && (! exists($adresse_ID{$addr})) && ( ! exists( $adresse_reponse{$addr})) ) {
# uniquement a droite et ID pas encore cree
			$adresse_ID{$addr}  = $compteur_routeur ;
			$ID_routeur=$compteur_routeur ;
			%{$table_noeud[$ID_routeur]} -> { "NOEUDID"} = $ID_routeur ;
			%{$table_noeud[$ID_routeur]} -> { "TYPENOEUD"} = "ROUTEUR" ;
			%{$table_noeud[$ID_routeur]} -> { "ADDR"} = $addr ;
			%{$table_noeud[$ID_routeur]} -> { "NOMR"} = &fqdnsub($addr) ; 
			%{$table_noeud[$ID_routeur]} -> { "VISITE" } = "NONVISITE" ;
			%{$table_noeud[$ID_routeur]} -> { "LISTINT" } =  () ;
			$compteur_routeur ++ ;
		}
	}

### 
	my($addr, $num_switch, $dist, $i);
#foreach $addr (keys %est_switch ) { print " $addr $est_switch{$addr} " } ;
#print " \n";
# on cree les switchs
	$compteur_switch  = $compteur_routeur;
	foreach $addr (keys %est_switch) {
# on regarde si cette interface est deja attribuée a un switch
		if ( exists( $interface_switch{$addr} ) ) {
# on recupere le numero 
			$num_switch = $interface_switch{$addr} ;
		} else {
#il faut verifier que les adresses distantes ne sont pas deja declarees : clique incomplete
# on teste si une adresse distante a deja un numero de switch mais ne pointait pas vers adresse locale
			$num_switch = -1;
			for ($i =1 ; $i <= $#{$interface_routeur{$addr}} ; $i++ ) {
				$dist = @{$interface_routeur{$addr}} [$i] ;
				if (exists $interface_switch{$dist} ) {
					$num_switch = $interface_switch{$dist} ;
				}
			}
			if ( $num_switch == -1 ) {
# on cree un switch de numero $compteur_switch
				$num_switch = $compteur_switch ;
				$compteur_switch ++ ;
			}
# on ajoute cette interface
			$interface_switch{$addr} = $num_switch ;
			%{$table_noeud[$num_switch]} -> { "NOEUDID"} = $num_switch ;
			%{$table_noeud[$num_switch]} -> { "TYPENOEUD"} = "SWITCH" ;
		}
# et dans les deux cas on ajoute toutes les interfaces distantes
#print "nombre interfaces $#{$interface_routeur{$addr}} \n";
		for ($i =1 ; $i <= $#{$interface_routeur{$addr}} ; $i++ ) {
			$dist = @{$interface_routeur{$addr}} [$i] ;
			$interface_switch{$dist} = $num_switch ;
		}
	}
# on imprime la table
	my($Nombreswitch) = $compteur_switch - $compteur_routeur ;
	print "Nombre total de switchs $Nombreswitch \n";
	print "Nombre total de routeurs $compteur_routeur \n";
# construction table_switch
	foreach $addr (keys %interface_switch ) {
# ajoute interface à liste
		push(@{$table_switch[@interface_switch{$addr}]}, $addr);
# ajouter interfaces du switch
		if (!exists (%{$table_noeud[@interface_switch{$addr}]}-> {"LISTINT"}) ) {
			%{$table_noeud[@interface_switch{$addr}]} -> { "LISTINT" } [0] -> {"ADDRD"} = $addr ;
			%{$table_noeud[@interface_switch{$addr}]} -> { "LISTINT" } [0] -> {"NOMDROIT"} = $fqdn{$addr} ;
			%{$table_noeud[@interface_switch{$addr}]} -> { "LISTINT" } [0] -> {"ASND"} = &Recherche_AS($addr) ;
		} else { 
			my(%h1) = ('ADDRD' =>  $addr, 'NOMDROIT' =>  $fqdn{$addr}, 'ASND' => &Recherche_AS($addr)) ;
			push(@{%{$table_noeud[@interface_switch{$addr}]}-> {"LISTINT"}}, \%h1) ;
		}
	}
## on calcule le prefixe des switchs
	foreach (@table_noeud) {
		if ( %{$_} -> {"TYPENOEUD"} eq "SWITCH" ) {
			my(@refliste) = @{%{$_}->{"LISTINT"}} ;
			my(@liste_add);
			foreach (@refliste) {
				my($addr) = %{$_} -> {"ADDRD"} ;
				push(@liste_add, %{$_} -> {"ADDRD"}) ;
			}
			%{$_}->{"ADDR"} = &Recherche_prefixe(@liste_add) ;
		}
	}
}
sub Recherche_prefixe{                     #Méthode de recherche de L'AS pour une interface
# en parametre global liste adresse IP
# on intialise l'adresse de base à la premire adresse et la longueur à 32
	my(@liste_add) =( @_) ;
	my($addr_base) = shift @liste_add ;
	my(@octets) = split('\.',$addr_base) ;
	my($addr_base_num) = ($octets[0] << 24) +( $octets[1] << 16) +( $octets[2] << 8) + $octets[3] ;
	my($long_pref) = 32 ;
	my($addr);
	foreach $addr (@liste_add) {
# on convertit adresse
		my(@octets) = split('\.',$addr) ;
		my($addr_num) = ($octets[0] << 24) +( $octets[1] << 16) +( $octets[2] << 8) + $octets[3] ;
# on met a zero les bits dans le subnet actuel
		$addr_num = $addr_num >> (32 - $long_pref ) ;
		$addr_num = $addr_num << (32 - $long_pref) ;
# dans le subnet ?
		if ($addr_num  == $addr_base_num ) {
# deja dans le subnet
			next ;
		} 
# pas dans le subnet
		while (($addr_num  != $addr_base_num ) && ($long_pref > 0) ) {
			$long_pref -- ;
			$addr_num = $addr_num >> (32 - $long_pref) ;
			$addr_num = $addr_num << (32 - $long_pref) ;
			$addr_base_num = $addr_base_num >> (32 - $long_pref) ;
			$addr_base_num = $addr_base_num << (32 - $long_pref) ;
		}
		if  ( $long_pref <= 16 ) {
			print FLOG "WARNING prefixe de longueur $long_pref pour $addr_base \n" ;
		}
	}
# on convertit en string
	$octets[0] = $addr_base_num & 0xFF ;
	$octets[1] = ( $addr_base_num >> 8) & 0xFF ;
	$octets[2] = ( $addr_base_num >> 16) & 0xFF ;
	$octets[3] = ( $addr_base_num >> 24) & 0xFF ;
	$addr = $octets[3] . "." . $octets[2] . "." . $octets[1] . "." . $octets[0] ;
	return "$addr/$long_pref" ;
}

sub adresse_globale {
# teste si l adresse est nulle ou privee
	my ($adresse) = shift ;
	if ( $adresse =~/0.0.0.0/ ) {
		return "LOCAL" ;
	}
	elsif ( $adresse =~/^(192.168.|10.|172.(16|17|18|19|20|21|22|23|24|25|26|27|28|29|30|31).)/ 
	      )  {
		return "PRIVATE" ;
	}
	else {
		return "GLOBAL" ;
	}
}

sub election_AS {
# on passe en parametre global Liste_addresses : un element par adresse
# cette liste comprend aussi les adresses vers des LAN
# en parametre l ID du routeur
	my($ID) = shift ;
# on commence par ne garder qu une copie de chaque adresse
	my(%hash_adresse_unique, @liste_AS, %compte) ;
	my(@adresse_unique);
	my(@trie, $ASN) ;
	my($adresse);
	for (@Liste_addresses) {$hash_adresse_unique{$_} = 1} ;
	@adresse_unique = keys %hash_adresse_unique ;
# maintenant on cree une liste d AS
	foreach $adresse (@adresse_unique) {
		if ( &adresse_globale($adresse) eq "GLOBAL" ) { push(@liste_AS, &Recherche_AS($adresse)) ;
		}
	}
# il faut maintenant compter les AS les plus frequents
	$compte{$_}++ for @liste_AS ;
	@trie = keys %compte ;
# construction table de table
	my(@table_AS) = ();
	my(@element) ;
	foreach $ASN (@trie) {
		@element = ( $ASN, $compte{$ASN} );
		push( @table_AS, [ @element] );
	}
# tri de la table par ordre decroissant du nombre d apparition de l'AS
	my(@table_AS_triee) = sort { $b->[1] <=> $a->[1] } @table_AS ;
	my($topas) = $table_AS_triee[0][0] ;
	my($confiance) ;
	if ( $#table_AS_triee == 0)  {
# un seul AS confiance 1
		$confiance = 1 ;
		$intra_domaine = 1 ; #sera remis en cause a la passe suivante 
	} else {
		$confiance = ($table_AS_triee[0][1] - $table_AS_triee[1][1] ) / $table_AS_triee[0][1] ;
#print " ID $ID  AS $topas confiance $confiance \n" ;
		$intra_domaine = 0;
	}
	%{$table_noeud[$ID]} -> {"ASN"} = $topas ;
	%{$table_noeud[$ID]} -> {"CONF"} = $confiance ;
	%{$table_noeud[$ID]} -> {"HISTO"} = "$step $topas $confiance " ;
# on stocke la table d'AS et frequence
	@{%{$table_noeud[$ID]} -> {"LISTAS"}} = @table_AS_triee ;
# calcul de l AS loopback si existe
	my($ASNL)= "";
	for (@Liste_addresses_loopback) {
		my($NEWAS) = &Recherche_AS($_);
		if ( ($ASNL ne "" ) && ( $ASNL ne $NEWAS)) {
			print "WARNING inconsistance des AS de loopback \n";
		} else {
			$ASNL = $NEWAS ;
		}
	}
	if ( $#Liste_addresses_loopback + 1 > 0 ) {
# il y a des adresses de loopback
		%{$table_noeud[$ID]}  -> {"ASNL"} = $ASNL ;
		if ( ($ASNL ne $topas ) || ($confiance < 1) ){
#print "WARNING ID $ID AS $topas conf $confiance Loopback $ASNL \n" ;
		}
		if ( ($ASNL ne $topas ) && ($confiance  > 0) ) {
#print "INCONSISTANCE ID $ID AS $topas conf $confiance Loopback $ASNL \n" ;
		}
	}
	return $topas ;
}


sub Recherche_AS{                     #Méthode de recherche de L'AS pour une interface
# en parametre adresse IP
	my($noeud)=@_[0];
# si adresse privee on retourne INCONNU
	if ( &adresse_globale($noeud) eq "PRIVATE" ) {
		return "INCONNU" ;
	}
#  on cherche si un prefixe couvre deja adresse
# on convertit l'adresse en entier
	my(@octets) = split('\.',$noeud) ;
	my($add_num)= ($octets[0] << 24) +( $octets[1] << 16) +( $octets[2] << 8) + $octets[3] ;
# on cherche prefixe par longueur decroissante
	my($masque) = 0xFFFFFFFF ;
	my($long_pref) = 32;
	while ($masque != 0) {
		$add_num = $add_num & $masque ;
		if ((exists ($prefixes_ASN{$add_num})) && ($prefixes_ASN{$add_num}[0] <= $long_pref) ) {
#	prefixes deja la, rendre ASN
			return $prefixes_ASN{$add_num}[1] ;
		} else {
# prefixe plus court
			$masque = $masque << 1 ;
			$long_pref --;
		}
	}
	if ( $WHOB eq "FAUX" ) {
# on ne va plus loin
		print FLOG "WARNING AS inconnu pour $noeud \n";
# on insere le /24 correspondant avec  AS INCONNU
		my($lprefixe) = 24;
		my($cprefixe) = $noeud ;
		my($octets) = split('\.',$cprefixe) ;
		my($add_num)= ($octets[0] << 24) +( $octets[1] << 16) +( $octets[2] << 8) ; # on n ajoute pas le dernier octet
			$prefixes_ASN{$add_num} [0] = $lprefixe ;
		my($nomAS) = "INCONNU" . $octets[0].".".$octets[1].".".$octets[2]."/".  $lprefixe ;
		$prefixes_ASN{$add_num} [1] = $nomAS ;
		print  FLOG  "WARNING PREFIXE INCONNU pour $noeud \n" ;
#return $nomAS ;
		return "INCONNU" ;
	}
	my($cmd2)="/usr/local/bin/whob $noeud";
	sleep(1) ; # on dort un peu pour ne pas se faire blacklister
		my(@tampon);
	my($output);
	$output=`$cmd2`;
	print "WHOB $cmd2  $output \n" ;
	@tampon=split(' ',$output);
	if ($tampon[0]=~/Failed/) {
		$output="NULL";  #Adresse non trouvé
			return $output;   
	}
	if ($tampon[0]=~/Bad/) {
		$output="NULL";   #On met de coté les adresse du type 0.0.0.0
			return $output;
	}
	if ($tampon[0]=~/Sorry/) {
		$output="NULL";  #Adresse non trouvé
			return $output;  
	}
	if ($output =~/\?/) {
		print FLOG "WARNING PREFIXE INCONNU pour $noeud \n";
# on insere le /24 correspondant avec  AS INCONNU
		my($lprefixe) = 24;
		my($cprefixe) = $noeud ;
		my($octets) = split('\.',$cprefixe) ;
		my($add_num)= ($octets[0] << 24) +( $octets[1] << 16) +( $octets[2] << 8) ; # on n ajoute pas le dernier octet
			$prefixes_ASN{$add_num} [0] = $lprefixe ;
		$prefixes_ASN{$add_num} [1] = "INCONNU" ;
		return "INCONNU" ;
	}
	$output= $tampon[3];
# insertion du nouveau prefixe
	my($cprefixe) = $tampon[4] ;
	my($lprefixe) = $tampon[4];
	$lprefixe =~ s/.*\/// ;
	$lprefixe =~ s/\).*// ;
	$cprefixe =~ s/\(// ;
	$cprefixe =~ s/\/.*// ;
#inserer prefixe apres l'avoir converti
	my(@octets) = split('\.',$cprefixe) ;
	my($add_num)= ($octets[0] << 24) +( $octets[1] << 16) +( $octets[2] << 8) + $octets[3] ;
	$prefixes_ASN{$add_num} [0] = $lprefixe ;
	$prefixes_ASN{$add_num} [1] = $output ;
	$Stat_prefixe ++;
	return $output;
}
sub deuxieme_passe {
# le but de cette deuxieme passe est
# de faire la correspondance entre adresse droite et ID du routeur/switch voisin
# de trouver l AS du routeur
# on parcourt tous les routeurs
	print FRESUME &cdate()  . " Election $step \n";
	foreach (@table_noeud) {
		if ( %{$_} -> {"TYPENOEUD"} eq "ROUTEUR" ) {
			undef @Liste_addresses ;
			undef @Liste_addresses_loopback ;
			my($addr) = %{$_} -> {"ADDR"} ;
			my($ID) = %{$_} -> {"NOEUDID"} ;
			push(@Liste_addresses, $addr);
			if ( (exists $loopback{$addr} ) && ( &adresse_globale($addr) eq "GLOBAL")) {
				push(@Liste_addresses_loopback, $addr);
			}
			if ((%{$_}->{"VISITE"} eq "VISITE"  ) && ( exists %{$_}->{"LISTINT"})) {
				my(@refliste) = @{%{$_}->{"LISTINT"}} ;
				foreach (@refliste) {
# on construit la liste des  adresses
					my($addr) = %{$_} -> {"ADDRG"} ;
					push(@Liste_addresses, $addr ) ;
					if ( (exists $loopback{$addr} ) && ( &adresse_globale($addr) eq "GLOBAL")) {
						push(@Liste_addresses_loopback, $addr);
					}
# on affecte ID du voisin
					if (&adresse_globale(%{$_} -> {"ADDRD"}) eq "GLOBAL" ) {
						if ( %{$_} -> {"TYPEINT"} eq "SWITCH" ) { 
							if ( ! exists %{$_} -> {"ADDRG"} ) {
								print "ADDRG de $ID existe pas \n" ;
							}
							my($addrg) = %{$_} -> {"ADDRG"} ;
							if ( ! exists $interface_switch{ $addrg} ) {
								print "ID$ID : interface_switch de $addrg existe pas \n" ;
							}

							my($voisin) = $interface_switch{ $addrg} ;
							if ( $voisin eq "" ) {
								print "ID$ID addrg $addrg voisin $voisin \n" ;
							}
							%{$_}-> {"VOISIN"} =  $interface_switch{ %{$_} -> {"ADDRG"}}  }
							elsif ( %{$_} -> {"TYPEINT"} eq "GLOBAL" ) { %{$_}-> {"VOISIN"} =  $adresse_ID{%{$_} -> {"ADDRD"}} }
							elsif ( %{$_} -> {"TYPEINT"} eq "TUNNEL" ) { %{$_}-> {"VOISIN"} =  $adresse_ID{%{$_} -> {"ADDRD"}} }
					}
				}
# on ajoute aussi ls adresses locales  ( GLOBAL -> 0.0.0.0 ) a la liste d'adresses
				my(@listloc) = keys (%{%{$_}->{"LISTLOC"}} ) ;
				@Liste_addresses = (@Liste_addresses,@listloc );
			} elsif (%{$_}->{"VISITE"} eq "VISITE"  ) {
# cas ou le noeud a ete visite mais a pas d interfaces globales
				my(@listloc) = keys (%{%{$_}->{"LISTLOC"}} ) ;
				@Liste_addresses = (@Liste_addresses,@listloc );
			}
# on determine AS
			my($ASN)=&election_AS($ID);
			$ID_ASN{$ID} = $ASN;
# calcul de l AS loopback si existe
			my($ASNL)= "";
			for (@Liste_addresses_loopback) {
				my($NEWAS) = &Recherche_AS($_);
				if ( ($ASNL ne "" ) && ( $ASNL ne $NEWAS)) {
					print "WARNING inconsistance des AS de loopback \n";
				} else {
					$ASNL = $NEWAS ;
				}
			}
			if ( $#Liste_addresses_loopback + 1 > 0 ) {
# il y a des adresses de loopback 
				%{$_} -> {"ASNL"} = $ASNL ;
				if ( $ASNL ne $ASN ) {
					print FLOG "WARNING ID $ID AS $ASN Loopback $ASNL \n" ;
				}
			}
			$ID_intra{$ID} = $intra_domaine ;
# la variable globale intra_domaine est affectee dans la fonction election_AS
# en particulier tous les routeurs non visites sont intra à ce stade
			if ( $intra_domaine == 1 ) { %{$_} -> {"INTER"} = "INTRA" } else {  %{$_} -> {"INTER"} = "INTER" }
		} elsif (%{$_} -> {"TYPENOEUD"} eq "SWITCH") {
#traitement switch
# on affecte ID du voisin
			my(@refliste) = @{%{$_}->{"LISTINT"}} ;
			undef @Liste_addresses ;
			foreach (@refliste) {
				if (&adresse_globale(%{$_} -> {"ADDRD"}) eq "GLOBAL" ) {
					push(@Liste_addresses, %{$_} -> {"ADDRD"});
					%{$_}-> {"VOISIN"} =  $adresse_ID{%{$_} -> {"ADDRD"}} ;
				}
			}
			my($ID) = %{$_} -> {"NOEUDID"};
			my($ASN)=&election_AS($ID);
			$ID_ASN{$ID} = $ASN;
		}
	}
}

sub methode_voisinage {    
	print "methode_voisinage \n";
	print FRESUME &cdate() . " Methode voisinage $step \n";
# on va appliquer repetitivement le principe :
# si R1 et R2 sont connectes par prefixe de AS1 et R1 est dans un AS2 avec confiance 1 alors R2 est dans AS1
# remarque si R2 est dans un autre AS avec confiance 1 on a une inconsistance
# on part des routeurs qui sont passes en confiance 1 liste  @newconf1  à lissue ds methodes loopback ou lan
	my($Statconfirm) = 0;
	my($Stataugmente) = 0;
	my($Statchange0) = 0;
	my($Statchange1) = 0;
	my($Statchange) =0;
	while ($#newconf1 + 1 >0 ) {
# la liste est non vide
		my($ID) = shift @newconf1 ;
		my($ASN) = %{$table_noeud[$ID]} -> {"ASN"};
		if ($ASN =~ /INCONNU/ ) {
# on ne traite pas les inconnus
			next ;
		}
# on parcourt les interfaces de type routeur
		foreach(@{%{$table_noeud[$ID]} -> {"LISTINT"}}) {
			my($ASG) = %{$_} -> {"ASNG"} ;
			my($voisin) = %{$_} -> {"VOISIN"};
			if ((%{$table_noeud[$voisin]} -> {"TYPENOEUD"} ne "ROUTEUR" ) || ( %{$_} -> {"ASNG"} =~ /INCONNU/) ){
# on ne traite pas les voisins SWITCHS ni les cas ou l'AS interco est inconnu
				next ;
			}
			my($ASvoisin) = %{$table_noeud[$voisin]} -> {"ASN"} ;
			if ( $ASvoisin =~ /INCONNU/ ) {
# on ne teste pas plus
				next ;
			}
			my($ASvoisinconf) = %{$table_noeud[$voisin]} -> {"CONF"};
			my($comment) = (exists %{$table_noeud[$voisin]} -> {"COMMENT"} ) ? %{$table_noeud[$voisin]} -> {"COMMENT"}  : "" ;
			if ($ASN ne $ASG) {
# interface pas dans AS du routeur
				if ($ASvoisin eq $ASG ) {
# le voisin est dans cet AS il suffit d'augmenter eventuellement la confiance
					if ($ASvoisinconf < 1 ) {
# on peut augmenter la confiance
						%{$table_noeud[$voisin]} -> {"CONF"} = 1;
# on stocke  le voisin pour le traiter
						%{$table_noeud[$voisin]} -> {"COMMENT"} = $comment . "Confirme voisin $ID " ;
						%{$table_noeud[$voisin]} -> {"HISTO"} = %{$table_noeud[$voisin]} -> {"HISTO"} . "$step $ASvoisin 1 " ;
						push(@newconf1, $voisin);
#print "Augmentation confiance $voisin \n" ;
						$Stataugmente ++;
					} else {
#print "Confirmation AS avec conf a 1 \n";
						$Statconfirm ++ ;
					}
				} else {
# changement d'AS si possible tester AS et confiance
					if ( $ASvoisinconf >= $seuilconf ) {
#print "INCONSISTANCE changement d'AS ID $voisin $ASvoisin => $ASG et conf 1 \n";
						%{$table_noeud[$voisin]} -> {"COMMENT"} = $comment . "Inconsistance voisin $ID " ;
						%{$table_noeud[$voisin]} -> {"HISTO_INC"} = %{$table_noeud[$voisin]} -> {"HISTO_INC"} . "I$step $ASG 0 ";
# on marque aussi inconsistance dans le routeur courant
						%{$table_noeud[$ID]} -> {"HISTO_INC"} = %{$table_noeud[$ID]} -> {"HISTO_INC"} . "I$step $ASG 0 ";

						$Statchange1 ++;
					} else {
# confiance < 1 on peut changer AS
# on teste si nouvel AS etait exaequo avec ancien
# chercher ASG
						if ( %{$table_noeud[$voisin]} -> {"LISTAS"} [0] [0] ne $ASvoisin ) {
# la confiance est pas 1 donc ASN inchange pourtant pas en tete  de LISTAS ?
							print "ERREUR AS du voisin  pas en tete de LISTAS monID$ID IDvoisin$voisin $ASvoisin \n" ;
							next ;
						}
						my($nocc1) = %{$table_noeud[$voisin]} -> {"LISTAS"} [0] [1];
						my($rang) = 1 ;
						while ( (%{$table_noeud[$voisin]} -> {"LISTAS"} [$rang] [0] ne $ASG ) && ( $rang < $#{%{$table_noeud[$voisin]} -> {"LISTAS"}} )) {
							$rang++ ;
						}
						if (%{$table_noeud[$voisin]} -> {"LISTAS"} [$rang] [0] ne $ASG ) {
							print "ERREUR ID $voisin AS $ASG non trouve dans LISTAS \n";
							next ;
						}
# nb occurences nouvel AS
						my($nocc2) = %{$table_noeud[$voisin]} -> {"LISTAS"} [$rang] [1] ;					
						if ( $nocc1 == $nocc2) {
# il ya des exaequo
							%{$table_noeud[$voisin]} -> {"COMMENT"} = $comment . "Changement ex-aequo voisin $ID " ;
							push(@newconf1, $voisin);
							$Statchange++ ;
							$Statchange0++ ;
						} else {
# il y a  changement avec un non ex aequo
							%{$table_noeud[$voisin]} -> {"COMMENT"} = $comment . "Changement non ex-aequo  voisin $ID " ;
							$Statchange++ ;
						}
# on fait les changements
						%{$table_noeud[$voisin]} -> {"CONF"} = 1;
						push(@newconf1, $voisin);
						%{$table_noeud[$voisin]} -> {"ASN"} = $ASG ;
						%{$table_noeud[$voisin]} -> {"HISTO"} = %{$table_noeud[$voisin]} -> {"HISTO"}  . "C$step $ASG 1 " ;

					}
				}
			}
		}
	}
	print "Stats methode voisinage\n";
	print "Confirmations confiance deja 1 :  $Statconfirm Augmente conf $Stataugmente \n";
	print "Changements AS $Statchange dont entre ex-aequo $Statchange0 Inconsistances $Statchange1 \n";
# on marque aussi les noeud inchangés
	&marquage_vide($step) ;
}
sub liste_noeud {
# creation fichier liste des noeudsa dont le nom est passé en paramètre
	my($NomFichierListeNoeud) = shift ;
	open (FLISTENOEUD, "> $NomFichierListeNoeud" ) || die("Impossible ouvrir fichier liste noeud : $NomFichierListeNoeud");
	open (FLISTENOEUD_INC, "> $NomFichierListeNoeud.inc" ) || die("Impossible ouvrir fichier liste noeud- inconsistances  : $NomFichierListeNoeud.inc");

# on liste d abord les switchs 
	foreach (@table_noeud) {
		if ( %{$_} -> {"TYPENOEUD"} eq "SWITCH" ){
			my($ID) = %{$_} -> {"NOEUDID"};
			my($AS) = %{$_} -> {"ASN"};
			my($inter) = %{$_} -> {"INTER"};
			print FLISTENOEUD "SWITCH ID$ID $inter $AS  \n";
		}
	}
# on liste maintenant les routeurs visités
	foreach (@table_noeud) {
		if ( %{$_} -> {"VISITE"} eq "VISITE" ){
			my($ID) = %{$_} -> {"NOEUDID"};
			my($AS) = %{$_} -> {"ASN"} ;
			my($inter) = %{$_} -> {"INTER"} ;
			my($conf) = %{$_} -> {"CONF"};
			my($histo) = %{$_} -> {"HISTO"} ;
			my($histo_inc) = %{$_} -> {"HISTO_INC"};
			if ($conf == 0) {
#lister tous les AS ex-aequo
				my($freq) =  %{$_} -> {"LISTAS"} [0][1] ;
				my($ASEX) = %{$_} -> {"LISTAS"} [0][0] ;
				my($nas) = #$%{$_} -> {"LISTAS"} ;
				my($i) = 1;
				while ($nas >= $i) {
					if ( $freq  == %{$_} -> {"LISTAS"} [$i][1] ) {
						$ASEX = $ASEX . "," . %{$_} -> {"LISTAS"} [$i][0] ;
						$i++;
					} else {
# plus d'exaequo
						next ;
					}
				}
				$AS=$ASEX ;
			}
			print FLISTENOEUD "ROUTEUR ID$ID $inter $AS($conf) $histo \n";
			if (exists %{$_} -> {"HISTO_INC"} ) {
				my($histo_inc) = %{$_} -> {"HISTO_INC"};
				print FLISTENOEUD_INC "ROUTEUR ID$ID $inter $AS($conf) $histo_inc \n";
			}
		}
	}
	close (FLISTENOEUD);
}
sub liste_graphe()  {
# creation du fichier graphe dont le nom est passe en paramêtre
	my($NomFichierGraphe) = shift ;
	open (FGRAPHE, "> $NomFichierGraphe" ) || die("Impossible ouvrir fichier graphe : $NomFichierGraphe");
# on liste les  routeurs visités et switchs dans l'ordre des ID
# on liste d abord les switchs
	foreach (@table_noeud) {
		if (( %{$_} -> {"TYPENOEUD"} eq "SWITCH" ) || ( %{$_} -> {"VISITE"} eq "VISITE" ) ){
			my($ID) = %{$_} -> {"NOEUDID"};
			&imprime_routeur_resume($ID) ;
		}
	}
	close (FGRAPHE) ;
}

sub inter_intra {
# on passe en revue les switchs pour determiner INTER ou INTRA
# suivant que tous les routeurs voisins sont dans le même AS ou non
# puis passe en revue tous les routeurs visites  et positionne le champ INTER
# on en profite pour tester les cas où un préfixe joignant 2 routeurs n'est dans l'AS d'aucun de ces deux routeurs
	my($nswitch_inter) = 0;
	my($nswitch_intra) = 0;
	foreach (@table_noeud) {
		if ( %{$_} -> {"TYPENOEUD"} eq "SWITCH" ){
# on parcourt les AS des routeurs voisins
			my(%AS) =();
			my($inter) = "INTRA" ;
			foreach (@{%{$_}-> {"LISTINT"}} ) {
				my($IDvoisin) = %{$_}  -> {"VOISIN"} ;
				my($asvoisin) = %{$table_noeud[$IDvoisin]}  -> {"ASN"} ;
				$AS{$asvoisin} = 1;
			}
			my(@listas) = keys %AS;
			if ($#listas > 0 ) {
# il y a au moins 2 AS differents donc switch INTER
				%{$_} -> {"INTER"} = "INTER" ;
				$nswitch_inter++;
			} elsif ( $#listas == 0) {
# un seul AS donc INTRA
				%{$_} -> {"INTER"} = "INTRA" ;
				$nswitch_intra++;
			} else {
				print "WARNING cas impossible \n" ;
			}
		}
	}
	print "Nombre de switchs intra : $nswitch_intra, inter : $nswitch_inter \n";
	my($changeinter) = 0;
	my($nanomalie) = 0;
	my($ninter) = 0;
	my($nintra) = 0;
	my($ninter1AS) = 0;
# on parcourt maintenant les routeurs visites
# on leur affece un stautut itre ou intra et pour les inter on calcule le nom "interne"
	foreach (@table_noeud) {
		if ( %{$_} -> {"VISITE"} eq "VISITE" ){
# on teste les AS de chaque voisin
			my($ID) = %{$_} -> {"NOEUDID"};
			my($monAS) = %{$_} -> {"ASN"} ;
			my($inter) = "INTRA" ;
			my($nom_interne) = "";
			foreach (@{%{$_}-> {"LISTINT"}} ) {
				my($voisin) = %{$_}  -> {"VOISIN"} ;
				my($ASprefixe) = %{$_}  -> {"ASNG"} ;
				my($ASvoisin) =  %{$table_noeud[$voisin] } -> {"ASN"} ;
				my($typeswitch) = "";
# on teste si interface avec un switch INTER
				if ( %{$table_noeud[$voisin] } -> {"TYPENOEUD"} eq "SWITCH") {
					$typeswitch = %{$table_noeud[$voisin] } -> {"INTER"};
				} 
				if (($ASvoisin  ne $monAS )|| ($typeswitch eq "INTER")) {
					$inter="INTER" ;
				}
				if (($ASprefixe ne $monAS) && ($ASprefixe ne $ASvoisin)) {
					my($maconf) = %{$table_noeud[$ID] } -> {"CONF"} ;
					my($saconf) = %{$table_noeud[$voisin] } -> {"CONF"} ;
					my($addpref) = %{$_}  -> {"ADDRG"} ;
#print "Anomalie interco $ID adresse  $addpref  $ASprefixe moi $monAS($maconf) lui $ASvoisin($saconf) \n";
					$nanomalie ++;
				}
# si interface intra on memorise le nom
				my($addrg) = %{$_}  -> {"ADDRG"};
				if(( $ASprefixe  eq $monAS ) &&  ( exists $fqdn{$addrg} ) ) {
# interface interne qui a un nom
					$nom_interne = $fqdn{$addrg} ;
				}
			}
# on essaie d'affecter un nom
			my($ASrepondeur) = &Recherche_AS(%{$_} -> {"ADDR"}) ;
			if (($ASrepondeur eq $monAS ) &&  (%{$_} -> {"NOMR"} ne "" ) ) {
#repondeur intra et a un  nom
				$nom_interne = %{$_} -> {"NOMR"} ;
			} # sinon le nom interne est celui d'une interface si il y en a une
			if ($nom_interne ne "") {
				%{$_} -> {"NOM_INTERNE"} = $nom_interne;
			}
			if ( $inter ne %{$_} -> {"INTER"} ) {
				%{$_} -> {"INTER"} = $inter ;
				$changeinter ++;
			}
			my($size) = $#{%{$table_noeud[$ID]} -> {"LISTAS"} } ;
			if ( ($size ==  0 ) && (%{$_} -> {"INTER"} eq "INTER" )) {
# ce routeur est inter bien que toutes ses interfaces soient dans le même AS
				$ninter1AS ++ ;
			}
			if ( $inter eq "INTER" ) {
				$ninter ++;
			} elsif ( $inter eq "INTRA" ) {
				$nintra ++ ;
			} else {
				print "WARNING cas impossible $ID \n" ;
			}
		} elsif (( %{$_} -> {"TYPENOEUD"} eq "ROUTEUR" ) && ( %{$_} -> {"VISITE"} ne "VISITE" ) ) {
# cas des routeurs non visites
# on recherche de qui il est voisin
			my($mon_addr) = %{$_} -> {"ADDR"} ;
			if (exists $interface_switch{$mon_addr } ) {
# voisin d un switch
				my($switch) = $interface_switch{$mon_addr } ;
				%{$_} -> {"INTER"} = %{$table_noeud[$switch]} -> {"INTER"} ;
			} else  {
				my($avoisin) = $interface_droite{ $mon_addr } ;
				my($IDvoisin)  = $adresse_ID{$avoisin} ;
				my($ASvoisin) = %{$table_noeud[$IDvoisin]} -> {"ASN"} ;
				if ( $ASvoisin eq  %{$_} -> {"ASN"}  ) {
# intra
					%{$_} -> {"INTER"} = "INTRA";
				} else {
# inter
					%{$_} -> {"INTER"} = "INTER" ;
				}
			}
# on en profite pour lui donner un nom si on peut
			if (exists $fqdn{$mon_addr} ) {
				%{$_} -> {"NOMR"} = $fqdn{$mon_addr} ;
			}
		}
	}
#print "Nombre de routeurs Intra $nintra Inter $ninter (dont $ninter1AS 1 seul AS) Changements inter/intra $changeinter anomalies interco $nanomalie \n";
	print "Nombre de routeurs Intra $nintra Inter $ninter (dont $ninter1AS 1 seul AS) \n";
}
sub domaines_differents  {
# on teste les cas où un préfixe joignant 2 routeurs  est dans 2 top domaines différents
	my($changeinter) = 0;
	my($nanomalie) = 0;
	my($domaindiff) = 0;
	my($domaindiffintra) = 0;
	my($domaindiffinter) = 0;
	foreach (@table_noeud) {
		if ( %{$_} -> {"VISITE"} eq "VISITE" ){
# on teste les AS de chaque voisin
			my($ID) = %{$_} -> {"NOEUDID"};
			my($monAS) = %{$_} -> {"ASN"} ;
			my($maconf) = %{$_} -> {"CONF"};
			foreach (@{%{$_}-> {"LISTINT"}} ) {
				my($voisin) = %{$_}  -> {"VOISIN"} ;
				my($ASprefixe) = %{$_}  -> {"ASNG"} ;
				my($ASvoisin) =  %{$table_noeud[$voisin] } -> {"ASN"} ;
# on teste aussi si les domaines à drite et a gauche sont differents
				if ( (exists  $fqdn{%{$_} -> {"ADDRG"}} ) && ( exists $fqdn{%{$_} -> {"ADDRD"}} )) {
					my($nomg) =  $fqdn{%{$_} -> {"ADDRG"}} ;
					my($nomd) =  $fqdn{%{$_} -> {"ADDRD"}} ;
					my(@tgauche) = split('\.', $nomg);
					my(@tdroite) = split('\.', $nomd);
# les noms de domaine ont au moins 2 composants et 
# les top domaines sont differents en minusule ou bien
#  les sous top domaines sont differents en minuscule
					if ((( $#tgauche > 0) && ($#tdroite > 0))&& ((lc($tgauche[$#tgauche])  ne lc($tdroite[$#tdroite])) || (lc($tgauche[$#tgauche-1])  ne lc($tdroite[$#tdroite-1])))) {
#print "DOMAIN ID$ID INTRA et interface $nomg  => ID$voisin $nomd \n";
						$domaindiff ++ ;
						my($saconf) =  %{$table_noeud[$voisin] } -> {"CONF"};
						if (( %{$table_noeud[$ID] } -> {"INTER"} eq "INTRA" ) && ( %{$table_noeud[$voisin] } -> {"VISITE"} eq "VISITE") ) {
# un routeur intra a une interface inter
#print "DOMAIN ID$ID INTRA et interface $nomg ($maconf) => ID$voisin $nomd($saconf) \n";
							$domaindiffintra ++;
						} elsif ( ( %{$table_noeud[$ID] } -> {"INTER"} eq "INTER" ) && ( %{$table_noeud[$voisin] } -> {"VISITE"} eq "VISITE") && ($monAS eq $ASvoisin )) {
#  le lien est interdomaine mais les 2 routeurs sont visités et dans le même AS
#print "DOMAIN ID$ID INTER et interface $nomg ($maconf) AS$monAS => ID$voisin $nomd($saconf) AS$ASvoisin \n";
							$domaindiffinter ++ ;
						}
					}
				}
			}
		}
	}
	print "Differences de top domaine $domaindiff dont source INTRA $domaindiffintra , INTER mais meme AS $domaindiffinter  \n";
}
sub methode_lan {
	print "methode interface lan\n";
	print FRESUME &cdate() . " Methode LAN $step \n" ;
# on se sert des adresses lan pour déterminer l'AS
# une interface lan correspond à une ligne mrinfo telle que
#  A -> 0.0.0.0  et A est une adrese globale
# l idee est qu une interface lan a une forte probabilite d etre dans le meme AS que le routeur 
# on lit le fichier  même nom que le fichier de collecte avec local- en prefixe
#my($NomFichierLocal) = "local-" . $NomFichierEntree ;
	my($lignes) ;
	my(@listecode) = ("a","b","c","d");
	my($code) ;
	my(%adresse) =() ;
	my(%confirme) = () ;
	my(%augmente) = ();
	my(%exaequo) = () ;
	my(%inconsistance) = () ;
	my(%grandeinconsistance) = ();
	foreach $code (@listecode) {
		$inconsistance{$code} = 0 ;
		$grandeinconsistance{$code} = 0 ;
	}
	open (FLOCAL, "$NomFichierLocal"  ) || die("Impossible ouvrir $NomFichierLocal");
	while ($lignes =<FLOCAL> ) {
		my(@listechamps) = split( ' ',  $lignes);
		my($adresselocale) = $listechamps[0] ;
		my($ID) = $adresse_ID{$adresselocale} ;
		my($monAS) = %{$ table_noeud[$ID]} -> {"ASN"} ;
		my($conf) = %{$table_noeud[$ID]} -> {"CONF"};
		$code = $listechamps[1] ;
		if ($code ne "?" ) {
			if (($code eq "d") && ( $LANsansd eq "VRAI")){
# on ne traite pas les cas d
				next ;
			}
			$adresse{$code}  ++ ;
# on recupere AS associé
			my($ASlocal) = $listechamps[2] ;
# on supprime les [] qui entourent ASN dans les cas c et d
			$ASlocal =~ s/\[// ;
			$ASlocal =~ s/\]// ;
# VERRUE
			if ($ASlocal eq 69999 ) {
				next ;
			}
			if ($ASlocal eq 0 ) {
# cas des adresses non routables, on skip
				next ;
			}

# on teste si AS donne par local a une frequence 1
			my($i) = 0;
			my($size) = $#{%{$table_noeud[$ID]} -> {"LISTAS"} } ;
			while ( (%{$table_noeud[$ID]} -> {"LISTAS"} [$i] [0] ne $ASlocal ) && ( $i <= $size)) {
				$i ++ ;
			}
			if ( $i > $size ) {
				print "ERREUR ID$ID ASlocal$ASlocal $lignes \n" ;
				next ;
			}
			my($freq) = %{$table_noeud[$ID]} -> {"LISTAS"} [$i] [1] ;
#print "LOCAL ID$ID ASlocal$ASlocal Freq$freq \n" ;
			if ( $freq == 1) {
# AS de interface locale represente que par cette interface : on ignore
				next ;
			}
			my($comment) = ( exists %{$table_noeud[$ID]} -> {"COMMENT"} ) ? %{$table_noeud[$ID]} -> {"COMMENT"} : "" ;
			if ( ( $monAS eq $ASlocal) && ($conf == 1.)) {
# tout baigne
				$confirme{$code} ++ ;
				%{$table_noeud[$ID]} -> {"COMMENT"} = $comment . "Confirme LAN" ;
			} elsif ( ( $monAS eq $ASlocal) && ($conf <  1.) && ( $conf > 0.)) {
# on augmente la confiance à 1
				$augmente{$code} ++ ;
				%{$table_noeud[$ID]} -> {"CONF"}  = 1;
				%{$table_noeud[$ID]} -> {"COMMENT"} = $comment . "Confirme LAN" ;
				%{$table_noeud[$ID]} -> {"HISTO"} = %{$table_noeud[$ID]} -> {"HISTO"} . "$step $monAS 1 " ;
				push(@newconf1, $ID);
			} elsif ( $conf ==  0.) {
# exaequo
#print "LOCAL type $code exaequo ID$ID IP$adresselocale AS$monAS($conf)  $ASlocal \n" ;
				%{$table_noeud[$ID]} -> {"COMMENT"} = $comment . "EX-aequo LAN" ;
				%{$table_noeud[$ID]} -> {"CONF"}  = 1;
				%{$table_noeud[$ID]} -> {"HISTO"} = %{$table_noeud[$ID]} -> {"HISTO"} . "$step $monAS 1 " ;
				push(@newconf1, $ID);
				$exaequo{$code} ++ ;
			} else {
# inconsistance
#print "LOCAL type $code  changement  ID$ID IP$adresselocale AS$monAS($conf)  $ASlocal \n" ;
				$inconsistance{$code} ++ ;
				if ( $conf >=  $seuilconf) {
					$grandeinconsistance{$code}  ++ ;
#print "INCONSISTANCE ID$ID IP$adresselocale AS$monAS($conf)  $ASlocal\n" ;
					%{$table_noeud[$ID]} -> {"COMMENT"} = $comment . "Grande Inconsistance LAN" ;
					%{$table_noeud[$ID]} -> {"HISTO"} = %{$table_noeud[$ID]} -> {"HISTO"} . "I$step $ASlocal 0 ";
					%{$table_noeud[$ID]} -> {"HISTO_INC"} = %{$table_noeud[$ID]} -> {"HISTO_INC"} . "I$step $ASlocal 0 ";
				} else {
# confiance pour  autre AS inferieure au seuil on change quand meme
					%{$table_noeud[$ID]} -> {"CONF"}  = 1;
					%{$table_noeud[$ID]} -> {"ASN"} = $ASlocal ;
					push(@newconf1, $ID);
					%{$table_noeud[$ID]} -> {"COMMENT"} = $comment . "Petite inconsistance LAN" ;
					%{$table_noeud[$ID]} -> {"HISTO"} = %{$table_noeud[$ID]} -> {"HISTO"} . "C$step $ASlocal 1 " ;
				}
			}
		}
	}
	print "Seuil grande inconsistance $seuilconf \n ";
	foreach $code (@listecode) {

		print "#Adresses locales avec code $code : $adresse{$code}  confirme $confirme{$code} augmente $augmente{$code} exaequo $exaequo{$code} inconsistant $inconsistance{$code} dont grande inconsistance $grandeinconsistance{$code}   \n" ;
	}
# on marque aussi les noeud inchangés
	&marquage_vide($step) ;
}
sub marquage_vide () {
# ajoute si besoin un marquage vide à l'historique de chaque routeur a l'étape passée en paramètre
	my($step) = shift;
	foreach (@table_noeud) {
		if (( %{$_} -> {"TYPENOEUD"} eq "ROUTEUR" ) && (  %{$_} -> {"VISITE"} eq "VISITE" )) {
			if ( %{$_} -> {"HISTO"} =~ /$step/ ) {
# dela marque pour cette etape
				next;
			}
			%{$_} -> {"HISTO"} = %{$_} -> {"HISTO"} . "$step * * " ;
		}
	}
}

sub methode_loopback_tunnel {
# methode qui traite les adresses de loopback et les adresses tunnel
	print "Methode Loopback \n";
	print FRESUME &cdate() . " Methode loopback $step \n";
	my($nconf) =0; # changement confiance sans changement AS
		my($nchange) = 0; # changement AS
		my($nchange0) = 0; # changement AS avec conf = 0
		my($nparcouru) = 0 ;
	my($nconf1) = 0; # conf a 0
		my($nconf0) = 0; # conf a 1
		foreach (@table_noeud) {
			if (( %{$_} -> {"TYPENOEUD"} eq "ROUTEUR" ) && (  %{$_} -> {"VISITE"} eq "VISITE" )) {
				$nparcouru++;
				my($ID) = %{$_} -> {"NOEUDID"} ;
				my($comment) = ( exists %{$_} -> {"COMMENT"} ) ? %{$_} -> {"COMMENT"} : "" ;
				my($conf) = %{$_} -> {"CONF"} ;
				if ( $conf == 1) { 
					$nconf1 ++ ;
				} elsif ( $conf == 0 ) { 
					$nconf0 ++ ;
				}
				my($AS1) = %{$_} -> {"ASN"} ;
				my($ASNL) = "" ;
				if ( exists %{$_} -> {"ASNL"}) {
					my($AS3) = %{$_} -> {"ASNL"} ;
					$ASNL = "ASNL" . $AS3;
					if (($AS3 eq $AS1) && ($conf <  1)) {
# on augmente la confiance à 1
						%{$_} -> {"CONF"} = 1;
						$nconf ++ ;
						%{$_} -> {"COMMENT"} = $comment . "Confirme Loopback" ;
						%{$_} -> {"HISTO"} = %{$_} -> {"HISTO"} . "$step $AS1 1 ";
						push(@newconf1, $ID);
					} elsif ( $AS3 ne $AS1) {
# changement d'AS
						if ( $conf < $seuilconf ) {
							$nchange ++;
							%{$_} -> {"ASN"} = $AS3 ;
							%{$_} -> {"COMMENT"} = $comment . "Change Loopback from $AS1" ;
							%{$_} -> {"CONF"} = 1;
							%{$_} -> {"HISTO"} = %{$_} -> {"HISTO"} . "C$step $AS3 1 ";
							push(@newconf1, $ID);
							if ($conf == 0 ) { 
								$nchange0 ++ ;
							}
						} else {
# on a une inconsistance
							%{$_} -> {"COMMENT"} = $comment . "Inconsistance Loopback" ;
							%{$_} -> {"HISTO"} = %{$_} -> {"HISTO"} . "I$step $AS3 0 ";
							%{$_} -> {"HISTO_INC"} = %{$_} -> {"HISTO_INC"} . "I$step $AS3 0 ";
						}
					}
				}
				my($ASNT) = "";
# traitement des tunnels
# si le parametre global $TRAITETUNNEL est à faux ASNT n existe pas donc operation vide ci-dessous
				if ( exists %{$_} -> {"ASNT"} ) {
					my($AS2) = %{$_} -> {"ASNT"} [0] ;
					$ASNT = "ASNT" . $AS2 ;
					if (($AS2 eq $AS1 ) && ($conf < 1)) {
# on augmente la confiance
						%{$_} -> {"CONF"} = 1;
						%{$_} -> {"COMMENT"} = $comment . "Confirme Tunnel"  ;
						push(@newconf1, $ID);
						$nconf ++ ;
					} elsif ($AS2  ne $AS1) {
# changement d'AS
						$nchange ++;
						$nconf++ ;
						%{$_} -> {"ASN"} = $AS2 ;
						%{$_} -> {"CONF"} = 1;
						%{$_} -> {"COMMENT"} = $comment . "Change Tunnel from $AS1 " ;
						push(@newconf1, $ID);
						if ($conf == 0 ) { 
							$nchange0 ++ ; 
						}	
					}
				}
#print "ID" .$ID . " " .$AS1 . " " .$conf . " " . $ASNL . " " .$ASNT . "\n" ;
			}
		}
	my($nconfi) = $nparcouru - $nconf1 -$nconf0 ;
	print "Avec TRAITETUNNEL $TRAITETUNNEL \n";
	print  "Parcouru  $nparcouru confiance 1 :  $nconf1 confiance 0 :  $nconf0 confiance 0< x < 1 : $nconfi \n" ;
	print "Augmentation de confiance $nconf dont changement AS $nchange dont avec ex-aequo  $nchange0 \n" ;
# on marque aussi les noeud inchangés
	&marquage_vide($step) ;
}

sub methode_grosse_confiance () {
# methode grosse confiance
# cette methode augmente à 1 touts ls confiancs superieures au seuil $grosse_conf
# dans le but d'appliquer ensuite la metheode voisinage
	my($grosse_conf) = shift ;
	print "Methode grosse confiance avec seuil $grosse_conf \n";
	print FRESUME &cdate() . " Methode grosse confiance $step avec seuil $grosse_conf \n" ;
	my($nconf) =0; # changement confiance sans changement AS
		my($nchange) = 0; # changement AS
		my($nchange0) = 0; # changement AS avec conf = 0
		my($nparcouru) = 0 ;
	my($nconf1) = 0; # conf a 0
		my($nconf0) = 0; # conf a 1
		foreach (@table_noeud) {
			if (( %{$_} -> {"TYPENOEUD"} eq "ROUTEUR" ) && (  %{$_} -> {"VISITE"} eq "VISITE" )
					&& ( %{$_} -> {"CONF"} > $grosse_conf) && ( %{$_} -> {"CONF"} < 1) ) {
# on passe la conf à 1 et on le note dans comment
				%{$_} -> {"CONF"} = 1;
				my($id) = %{$_} -> {"NOEUDID"} ;
				my($as) = %{$_} -> {"ASN"};
#commentaire
				%{$_} -> {"COMMENT"}  = (exists %{$_} -> {"COMMENT"} ) ? %{$_} -> {"COMMENT"} . " Conf GC " : " Conf GC" ;
				%{$_} -> {"HISTO"} = %{$_} -> {"HISTO"} . "$step $as 1 " ;
				push(@newconf1, $id ) ;
				$nconf1 ++ ;
			}
		}
	print "Passe grosse confiance avec seuil $grosse_conf : $nconf1 sont passes a 1 \n";
# on marque aussi les noeud inchangés
	&marquage_vide($step) ;
}

sub stat_confiance {
	my($nparcouru) = 0 ;
	my($nconf1) = 0; # conf a 1
		my($nconfg) = 0; # grande confiance mais < 1
		my($nconfp) = 0; #petite confiance mais > 00
		my($nconf0) = 0; # conf a 0
		my($conf);
	foreach (@table_noeud) {
		if (( %{$_} -> {"TYPENOEUD"} eq "ROUTEUR" ) && (  %{$_} -> {"VISITE"} eq "VISITE" )) {
			$nparcouru ++;
			$conf = %{$_} -> {"CONF"} ;
			if ( $conf == 1 ) {
				$nconf1 ++ ;
			} elsif ($conf >= $seuilconf ) {
				$nconfg ++ ;
			} elsif ($conf > 0 ) {
				$nconfp ++ ;
			} else {
				$nconf0 ++ ;
			}		

		}
	}
	print "Parcourus $nparcouru Confiance 1 : $nconf1, grande : $nconfg, petite : $nconfp, nulle : $nconf0 \n";
}
sub cdate () {
# retourne la date sans CR
	my($date) = `/bin/date "+%Y-%m-%d%H-%M-%S"` ;
	chomp($date);
	return $date;
}
sub methode_c2p () {
	print "methode c2p importée \n";
	print FRESUME &cdate() . " Methode c2p  $step \n" ;
	# on se sert du fichier .c2p qui déduit l'AS de la relation c2p en cas d'ex-aequo
	my($NomFichierC2P) = shift ;
	open (FC2P, "$NomFichierC2P"  ) || die("Impossible ouvrir $NomFichierC2P");
	my($lignes);
	while ($lignes =<FC2P> ) {
		if ($lignes =~ /--/ ) {
		# pas de c2p applicable
			next ;
		} 
		my(@ligne) = split(' ',$lignes);
		if ( $#ligne < 3 ) {
			# pas assez de parametre on saute
			print "c2p moins de 4 parametres $lignes \n";
			next ;
		}
		my($ID) = $ligne[0] ;
		$ID =~ s/.*ID// ;
		my($oldAS) = $ligne[1] ;
		my($newAS) = $ligne[2] ;
		my($conf) = $ligne[3] ;
		my($ASstocke) = %{$table_noeud[$ID]} -> {"ASN"} ;
		my($comment) = ( exists %{$table_noeud[$ID]} -> {"COMMENT"} ) ? %{$table_noeud[$ID]} -> {"COMMENT"} : "" ;
		if ( $ASstocke  ne $oldAS ) {
			# ya un lezard dans le fichier c2p
			print "Inconsistance pour ID$ID as stocke $ASstocke as fichier c2p $oldAS \n";
			next ;
		}
		if ($lignes =~ /-1-/ ) {
			# c2p confirme
			if ( $newAS ne $oldAS ) {
				#lezard
				print "c2p confirmation mais AS differents pour ID$ID \n";
				next ;
			}
		#	print "c2p confirme ID $ID oldAS $oldAS newAS $newAS conf $conf : $lignes \n" ;
			# on passe la confance à 1
			%{$table_noeud[$ID]} -> {"CONF"} = $conf ;
			push(@newconf1, $ID);
			%{$table_noeud[$ID]} -> {"COMMENT"} = $comment . "Confirme c2p" ;
			%{$table_noeud[$ID]} -> {"HISTO"} = %{$table_noeud[$ID]} -> {"HISTO"} . "C$step $newAS 1 " ;
			next;
		} elsif ($lignes =~ /-2-/ ) {
			# c2p changement AS
		#	print "c2p changement ID $ID oldAS $oldAS newAS $newAS conf $conf : $lignes \n" ;
			# on change AS
			%{$table_noeud[$ID]} -> {"ASN"} = $newAS ;
			%{$table_noeud[$ID]} -> {"CONF"} = $conf ;
			push(@newconf1, $ID);
			%{$table_noeud[$ID]} -> {"COMMENT"} = $comment . "Changement c2p" ;
			%{$table_noeud[$ID]} -> {"HISTO"} = %{$table_noeud[$ID]} -> {"HISTO"} . "C$step $newAS 1 " ;
			next;
		} else {
			# cas non prevu
			print "c2p non prevu $lignes \n" ;
			next ;
		}
	}
	&marquage_vide($step) ;
}
#################################################################################################
# debut programme principal
my($date_debut) = `date "+%Y-%m-%d%H-%M-%S"`;
chomp($date_debut);
my($argc)  = $#ARGV ;
my($Usage) = "Usage :  graphe.pl [-i] [-c] fichier-collecte fichier-prefixe fichier-lan [fichier c2p]  \n";
if ($argc < 2 ) {
	print  $Usage ;
	exit ;
} 
if ( $ARGV[0] =~ /-i/ ) {
# on est en mode interactif, il faut donc un paramètre de plus
	shift @ARGV ;
	$argc-- ;
	$ModeInteractif = "VRAI";
	if ( $argc < 2 ) {
		print $Usage ;
		exit ;
	}
} 
if ( $ARGV[0] =~ /-c/ ) {
# on est en mode c2p, il faut donc un paramètre de plus
	shift @ARGV ;
	$argc-- ;
	$ModeC2P = "VRAI";
	if ( $argc < 3 ) {
		print $Usage ;                exit ;
	} else { 
		$NomFichierC2P = $ARGV[3] ;
	}
} 


$NomFichierEntree=$ARGV[0] ;
$FichierPrefixeEntree=$ARGV[1] ;
$NomFichierLocal=$ARGV[2] ;
chomp($NomFichierEntree);
# ouverture du fichier de log
$NomFichierLog = "$NomFichierEntree".".log" ;
my($NomFichierResume) = "$NomFichierEntree".".resume" ;
open (FLOG, "> $NomFichierLog") || die ("Impossible ouvrir fichier de log  $NomFichierLog "); #fichier ouvert en écriture
print FLOG &cdate() , "\n";
print FLOG "Fichier analysé", $NomFichierEntree, "\n" ;
open (FRESUME, "> $NomFichierResume" ) || die ("Impossible ouvrir fichier de resume $NomFichierResume ") ; # fichire de stats generales
print FRESUME &cdate() . " Debut " . " Fichier collecte $NomFichierEntree, Fichier mapping prefixe $FichierPrefixeEntree, Fichier adresses locales $NomFichierLocal \n" ;
print FRESUME "Parametres TRAITETUNNEL: $TRAITETUNNEL, traite local cas d : $LANsansd, seuil confiance : $seuilconf \n";
#construction nom du fichier resultat
$NomFichierGraphe = "$NomFichierEntree".".graphe" ;
$NomFichierListeNoeud = "$NomFichierEntree".".liste" ;
# ouverture fichier prefixe
#my($FichierPrefixeEntree) = "Prefixes" ;
#my($FichierPrefixeEntree) = "" ;
my($formatBenoit) = "VRAI" ;
if ( $FichierPrefixeEntree ne "") {
       open(FICHIERPREFIXE, "$FichierPrefixeEntree") || die ("impossible ouvrir $FichierPrefixeEntree");
       # chargement des prefixes dans la table de hash %prefixes_ASN
       # format IP/longueur ASN
       #exemple
       #153.97.0.0/21 5501
       #137.251.0.0/16 5501
       #213.144.160.0/19 6762
       my($lignes);
       while ($lignes=<FICHIERPREFIXE>) {
		if ($formatBenoit eq "VRAI" ) {
       	        #lecture fichier préfixe au format de Benoit
               	#137.48.55.0 11546 (O) 7896 (O)
   	        	    # on ignore les lignes contenant "Number"
       	        if ( $lignes =~ /umber/ ) {
               	        next ;
	                }
       	        # on supprime tout ce qui suit une eventuelle virgule
               	$lignes =~ s/,.*// ;
	                my(@ligne) = split(' ',$lignes);
       	        # on supprime le saut de ligne
               	chomp(@ligne) ;
       	        my($ASN) =  $ligne[1];
               	my($cprefixe) = $ligne[0];
	               	my($lprefixe) = 24 ;
       	        my(@octets) = split('\.',$cprefixe) ;
               	my($add_num)= ($octets[0] << 24) +( $octets[1] << 16) +( $octets[2] << 8) + $octets[3] ;
	                $prefixes_ASN{$add_num} [0] = $lprefixe ;
       	        $prefixes_ASN{$add_num} [1] = $ASN;
		} else {
	               	my(@ligne) = split(' ',$lignes);
       	        # on supprime le saut de ligne
               	chomp(@ligne) ;
 	             	 my($ASN) =  $ligne[1];
        	      	 my($cprefixe) = $ligne[0];
               	$cprefixe =~ s/\/.*// ;
	              	 my($lprefixe) = $ligne[0];
       	        $lprefixe =~ s/.*\/// ;
               	my(@octets) = split('\.',$cprefixe) ;
 	             	 my($add_num)= ($octets[0] << 24) +( $octets[1] << 16) +( $octets[2] << 8) + $octets[3] ;
       	        $prefixes_ASN{$add_num} [0] = $lprefixe ;
               	$prefixes_ASN{$add_num} [1] = $ASN;
		}
       }
}      
&premiere_passe("$NomFichierEntree");
print FRESUME &cdate() . " fin premiere passe\n";
print FLOG "fin premiere passe\n";
close ("$NomFichierEntree");
$step="E";
&deuxieme_passe();
print FRESUME &cdate() . " Fin deuxieme passe \n";
print FLOG "Fin deuxieme passe \n";
&stat_confiance;
$step="Loop";
&methode_loopback_tunnel;
&stat_confiance;
if ($ModeInteractif eq "VRAI" ) {
	&imprime_routeur_interactif();
}
$step="V0";
&methode_voisinage();
$step="LAN";
&methode_lan ;
&stat_confiance;
$step="V1";
&methode_voisinage();
&stat_confiance;
my(@liste_conf) = (0.9, 0.8, 0.7, 0.6, 0.5, 0.4, 0.3, 0.2, 0.1);
my($i) =2 ;
foreach (@liste_conf) {
	my($conf) = $_ ;
	$step = "G$conf" ;
	&methode_grosse_confiance ($conf);
	&stat_confiance;
	$step="V$i";
	&methode_voisinage();
	&stat_confiance;
	$i ++ ;
}
if ($ModeC2P eq "VRAI") {
	$step = "C2P" ;
	&methode_c2p($NomFichierC2P) ;
	$step = "V11"  ;
	&methode_voisinage();
}
&inter_intra ;
&domaines_differents ;
&liste_noeud ($NomFichierListeNoeud);
&liste_graphe($NomFichierGraphe);
if ($ModeInteractif eq "VRAI" ) {
	&imprime_routeur_interactif();
}
print FLOG "Changement intra => inter troisieme passe $Stat_change_type \n";
print FLOG "Changement AS phase 3 : $Stat_desambi \n";
print FLOG "Routeurs $Stat_routeur dont non parcourus $Stat_routeur_distant Switchs $Stat_switch Prefixes $Stat_prefixe \n";
print "\n" ;
print FLOG "Fin", &cdate() , "\n" ;
close(FLOG);
print &cdate() . " Fin " , "\n" ;
print FRESUME &cdate() . " Fin ", "\n" ;
close (FRESUME);
